require 'twitter_oauth'

module Myun2
  class Twitter
    class Authenticate
      attr_reader :client, :authorize_url, :access_token

      def initialize(params)
        @client = TwitterOAuth::Client.new(params)
      end

      def request_authorize_url
        @token = client.authentication_request_token(oauth_callback: 'oob')
        @authorize_url = @token.authorize_url
      end

      def authorize(pin_code)
        @access_token = client.authorize(
          @token.token, @token.secret, oauth_verifier: pin_code)
      end
    end
  end
end

