require 'myun2/twitter/authenticate'

module Myun2
  class TwitterShell
    class Authorize
      attr_reader :pin, :access_token

      def initialize
        puts "* Requesting authorization URL ..."
        auth_url = request_authorize_url
        puts "  " + auth_url
        puts "* Please access to above URL in your browser."
        puts "  And permit application 'Myun2 Twitter Shell (Twsh)."
        puts "  And enter shown PIN code to under."
        print "PIN> "
        read_pin && authorize
      end

      def request_authorize_url
        @auth = Myun2::Twitter::Authenticate.new(
          consumer_key: ConsumerKey::KEY,
          consumer_secret: ConsumerKey::SECRET)
        @auth.request_authorize_url
      end

      def read_pin
        @pin = gets.chomp
      end

      def authorize
        @access_token = @auth.authorize(@pin)
      end
    end
  end
end
