require 'twitter'

module Myun2
  class TwitterShell
    class Ls
      attr_reader :client

      def initialize(client, *params)
        @client = client

        if params && params.length > 0
          case
          when params[0] == '-m' || params[0] == 'mention' || params[0] == 'mentions'
            params.shift
            timeline = mentions_timeline(*params)
          when params[0][0] != '-'
            user_name = params.shift
            timeline = user_timeline(user_name, *params)
          end
        end
        timeline ||= home_timeline(*params)

        timeline.each do |t|
          puts format(t, *params)
        end
      end

      def user_timeline(screen_name, *params)
        client.user_timeline({ screen_name: screen_name }.merge(params_to_options *params))
      end

      def mentions_timeline(*params)
        client.mentions(params_to_options *params)
      end

      def home_timeline(*params)
        client.home_timeline(params_to_options *params)
      end

      def format(tweet, *params)
        u = tweet['user']
        user_name = u['name']
        screen_name = u['screen_name']
        text = tweet['text']

        if params && params.length > 0 && params[0][0] == '-' && params[0].include?('l')
          datetime = tweet['created_at']
          "#{datetime} \e[38;5;#{u['id'] % 255}m<#{screen_name}:#{user_name}>\e[0m: #{text}"
        else
          "\e[38;5;#{u['id'] % 255}m<#{user_name}>\e[0m: #{text[0..30]}"
        end
      end

      private
      def params_to_options(*params)
        options = {}
        params.each do |param|
          options[:count] = $1.to_i if /\A-c=(\d+)\Z/ =~ param
        end
        options
      end
    end
  end
end
