module Myun2
  class TwitterShell
    class Profile
      attr_reader :data

      class Loader
        def self.load(path)
          return unless File.exist?(path)
          r = {}
          open(path).each do |line|
            key, value = line.chomp.split "="
            r[key.to_sym] = value
          end
          r
        end
      end

      def initialize(params = {})
        @data = params
      end

      def save
        Dir.mkdir Profile.root_dir unless File.exist?(Profile.root_dir)

        open(profile_path, "w") do |f|
          @data.each do |key,value|
            f.puts key.to_s + "=" + value.to_s
          end
        end
      end

      def self.load(path = nil)
        return unless data = Loader.load(path || default_profile_path)
        new(data)
      end

      def self.root_dir
        File.expand_path('~/.twsh')
      end

      def self.default_profile_path
        File.join(root_dir, 'profile')
      end

      def profile_path
        @profile_path ||= Profile.default_profile_path
      end
    end
  end
end
