require 'shell_base'
require 'myun2/twitter_shell/profile'
require 'myun2/twitter_shell/client'
require 'myun2/twitter_shell/login'
require 'myun2/twitter_shell/ls'
require 'myun2/twitter_shell/tail'

module Myun2
  class TwitterShell
    class Shell < ShellBase
      attr_reader :client

      def initialize(*params)
        if @profile = Profile.load
          @client = Client.new(@profile.data)
          if params && params.length > 0
            return self.send(*params)
          end
        else
          puts "Please first login"
        end

        version
        super
      end

      def tweet(*params)
        client.update params.join(" ")
        puts "Post was successfully."
      end
      alias p tweet
      alias t tweet
      alias post tweet
      alias update tweet

      def ls(*params)
        Ls.new(client, *params)
      end

      def tail(*params)
        #ls(*params)
        puts "Waiting for timelime..."
        if params[0] == '&'
          @tail_thread = Thread.start do
            Tail.new(@profile.data, *params)
          end
        else
          Tail.new(@profile.data, *params)
        end
      end

      def version
        puts "twsh #{VERSION}"
      end

      def prompt
        "twsh:$ "
      end

      def login(*params)
        Login.new(*params)

        @profile = Profile.load
        @client = Client.new(@profile.data)
      end
    end
  end
end
